package de.mpg.mpimet.yacgui.junit;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.fail;

import java.util.HashMap;
import java.util.Map;

import org.junit.Test;

import de.mpg.mpimet.yacgui.xml.Calendar;
import de.mpg.mpimet.yacgui.xml.Component;
import de.mpg.mpimet.yacgui.xml.Couple;
import de.mpg.mpimet.yacgui.xml.Coupling;
import de.mpg.mpimet.yacgui.xml.Dates;
import de.mpg.mpimet.yacgui.xml.Grid;
import de.mpg.mpimet.yacgui.xml.TimestepUnit;
import de.mpg.mpimet.yacgui.xml.Transient;

/**
 * Copyright (c) 2013 Max-Planck-Institute for Meteorology, Hamburg.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of Oracle or the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

public class CouplingTest {

	@Test
	public void testHashCode() {
		fail("Not yet implemented");
	}

	@Test
	public void testCoupling() {
		fail("Not yet implemented");
	}

	@Test
	public void testCouplingMapOfIntegerComponentMapOfIntegerTransientMapOfIntegerGridDatesTimestepUnitMapOfStringCouple() {
		fail("Not yet implemented");
	}

	@Test
	public void testAddComponent() {
		fail("Not yet implemented");
	}

	@Test
	public void testAddCouple() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetComponents() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetTransients() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetGrids() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetDates() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetTimestepUnit() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetCouples() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetComponents() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetTransients() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetGrids() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetDates() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetTimestepUnit() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetCouples() {
		fail("Not yet implemented");
	}

	@Test
	public void testEqualsObject() {
		Coupling coupling1 = createDummyCoupling();
		Coupling coupling2 = createDummyCoupling();
		Coupling coupling3 = new Coupling();
		assertEquals(coupling1, coupling2);
		assertFalse(coupling1.equals(coupling3));
	}

	private static Coupling createDummyCoupling() {
		Map<Integer, Component> components = new HashMap<Integer, Component>();
		Map<Integer, Transient> transients = new HashMap<Integer, Transient>();
		Map<Integer, Grid> grids = new HashMap<Integer, Grid>();
		Dates dates = new Dates("start", "end", Calendar.PROLEPTIC_GREGORIAN);
		TimestepUnit timestepUnit = TimestepUnit.DAY;
		Map<String, Couple> couples = new HashMap<String, Couple>();
		boolean stdoutRedirect = false;
		boolean rootRedirect = false;
		Coupling coupling = new Coupling(stdoutRedirect, rootRedirect, components, transients, grids, dates,
				timestepUnit, couples);
		return coupling;
	}
}
